const { GObject, Shell, St } = imports.gi;
const Lang = imports.lang;
const Main = imports.ui.main;
const Menu = Main.panel.statusArea.aggregateMenu.menu;
const PanelMenu = imports.ui.panelMenu;
const PopupMenu = imports.ui.popupMenu;
const SystemActions = imports.misc.systemActions;
const Gio = imports.gi.Gio;
const Me = imports.misc.extensionUtils.getCurrentExtension();



let separator1;
let lock;
let power;
let separator2;
let settingsicon;
let showsettings
let creado = false;

let settingsApp = Shell.AppSystem.get_default().lookup_app( 'gnome-control-center.desktop' );

function getSettings(){
let GioSSS = Gio.SettingsSchemaSource;
let schemaSource = GioSSS.new_from_directory(
  Me.dir.get_child("schemas").get_path(),
  GioSSS.get_default(),
  false
  );
let schemaObj = schemaSource.lookup(
'org.gnome.shell.extensions.simpleroffmenu', true) 
if(!schemaObj){
throw new Error ('cannot find schemas');
}
return new Gio.Settings({ settings_schema : schemaObj });
}




var _bringOut = new Lang.Class({
    Name: "Bring Out Submenu Of Power Off/Logout Button and Rearrange the Order of System Menu.",
    Extends: PanelMenu.SystemIndicator,
    
_init: function() {

        this._system = Main.panel.statusArea.aggregateMenu._system;
        this._systemActions = new SystemActions.getDefault();
        this._createSubMenu();
        Menu.box.remove_actor(this._system.menu.actor);
},

_createSubMenu: function() {

let bindFlags = GObject.BindingFlags.DEFAULT | GObject.BindingFlags.SYNC_CREATE;


  
      separator1 = new PopupMenu.PopupSeparatorMenuItem;
      Menu.addMenuItem(separator1);

if(showsettings){
creado = true;

      if (settingsApp) {
      let [name, icon] = [ settingsApp.get_name(), settingsApp.app_info.get_icon().names[0] ];
      settingsicon = new PopupMenu.PopupImageMenuItem(name, icon);
      settingsicon.connect('activate', () => { Main.overview.hide(); settingsApp.activate(); });
      Menu.addMenuItem(settingsicon); }
      else { log('Missing required core component Settings, expect trouble…'); settings = new St.Widget(); }
  
      lock = new PopupMenu.PopupImageMenuItem(_('Lock'), 'changes-prevent-symbolic');
      lock.connect('activate', () => { this._systemActions.activateLockScreen(); });
      Menu.addMenuItem(lock);
      this._systemActions.bind_property('can-lock-screen', lock, 'visible', bindFlags);

      separator2 = new PopupMenu.PopupSeparatorMenuItem;
      Menu.addMenuItem(separator2);
}


power = new PopupMenu.PopupImageMenuItem(_('Power Off'), 'system-shutdown-symbolic');
power.connect('activate', () => { this._systemActions.activatePowerOff(); });
Menu.addMenuItem(power);
this._systemActions.bind_property('can-power-off', power, 'visible', bindFlags);

},
    
destroy: function () {

Menu.box.remove_actor(separator1);
Menu.box.remove_actor(power);

if(creado){
Menu.box.remove_actor(lock);
Menu.box.remove_actor(settingsicon);
Menu.box.remove_actor(separator2);
}

Menu.box.add_actor(this._system.menu.actor)
}
});

function init() {

let modifiedMenu;
}

function enable() {
let settings = getSettings();
showsettings = settings.get_boolean('show-settings');

modifiedMenu = new _bringOut();
}

function disable() {
modifiedMenu.destroy();
}

